<template>
  <svg
    :height="height"
    :class="{ 'canvas-margins': !source.shouldSnap}"
    :width="source.width * zoom"
    :view-box="`0 0 40 ${source.width}`"
  >
    <g
      transform-origin="left"
      :transform="`scale(${zoom}, 1)`"
    >
      <slot
        :zoom="zoom"
        :width="source.width"
        :pixel-unit="source.pixelUnit"
        :displayed-timelines="computeDisplayedTimelines"
        :positions="computePositions"
      />
    </g>
  </svg>
</template>

<script lang="ts">
import type { Pixel, Source } from '@/data';
import {
  Component, Prop, Vue,
} from 'vue-property-decorator';

type DisplayedTimelines = 'musical' | 'date' | 'both';

@Component
export default class BCanvasTimeline extends Vue {
  @Prop({ required: true })
  source!: Source;

  @Prop({ default: 1 })
  zoom!: number;

  @Prop({ required: true })
  musicalQuality!: number;

  displayedTimelines: DisplayedTimelines = 'musical';

  height: Pixel = 20 as Pixel;

  mounted() {
    this.displayedTimelines = this.musicalQuality > 2 ? 'musical' : 'date';
  }

  toggleTimeline() {
    if (this.musicalQuality <= 2) {
      return;
    }
    if (this.displayedTimelines === 'musical') {
      this.displayedTimelines = 'date';
    } else {
      this.displayedTimelines = 'musical';
    }
  }

  get computeDisplayedTimelines() {
    if (this.displayedTimelines === 'both') {
      return { musical: true, date: true };
    }
    return {
      musical: this.displayedTimelines === 'musical',
      date: this.displayedTimelines === 'date',
    };
  }

  get computePositions() {
    if (this.computeDisplayedTimelines.musical && this.computeDisplayedTimelines.date) {
      return { musical: 0, date: 20 };
    }
    return { musical: 0, date: 0 };
  }
}
</script>

<style scoped lang="scss">
.canvas-timeline {
  pointer-events: none;
  &-top {
    opacity: 0.13;
  }
  &-bottom {
    opacity: 0.1;
  }
}

.canvas-margins {
  margin-left: 40px;
  margin-right: 40px;
  overflow: visible;
}
</style>
